# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.AssignedAddressInfo import AssignedAddressInfo  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.LearnedAddressInfo import LearnedAddressInfo  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.ReservedAddressInfo import ReservedAddressInfo  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class AddressAssignmentInfo(object):
    """AddressAssignmentInfo - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'ip_address': 'common.v1.config.IPAddress',
        'is_assigned': 'bool',
        'is_reserved': 'bool',
        'is_learned': 'bool',
        'assigned_details': 'networking.v4.config.AssignedAddressInfo',
        'learned_details': 'list[networking.v4.config.LearnedAddressInfo]',
        'reserved_details': 'networking.v4.config.ReservedAddressInfo',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ip_address': 'ipAddress',
        'is_assigned': 'isAssigned',
        'is_reserved': 'isReserved',
        'is_learned': 'isLearned',
        'assigned_details': 'assignedDetails',
        'learned_details': 'learnedDetails',
        'reserved_details': 'reservedDetails',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ip_address=None, is_assigned=None, is_reserved=None, is_learned=None, assigned_details=None, learned_details=None, reserved_details=None, *args, **kwargs):  # noqa: E501
        """AddressAssignmentInfo - a model defined in Swagger
            \nInformation pertaining to an assigned or reserved IP address on a subnet.
        """
        self.__ip_address = None
        self.__is_assigned = None
        self.__is_reserved = None
        self.__is_learned = None
        self.__assigned_details = None
        self.__learned_details = None
        self.__reserved_details = None
        self.discriminator = None
        if ip_address is not None:
            self.__ip_address = ip_address
        if is_assigned is not None:
            self.__is_assigned = is_assigned
        if is_reserved is not None:
            self.__is_reserved = is_reserved
        if is_learned is not None:
            self.__is_learned = is_learned
        if assigned_details is not None:
            self.__assigned_details = assigned_details
        if learned_details is not None:
            self.__learned_details = learned_details
        if reserved_details is not None:
            self.__reserved_details = reserved_details
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.AddressAssignmentInfo'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.AddressAssignmentInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ip_address(self):
        """`{ common.v1.config.IPAddress }`
            
        """ # noqa: E501
        return self.__ip_address

    @ip_address.setter
    def ip_address(self, ip_address):

        self.__ip_address = ip_address

    @property
    def is_assigned(self):
        """`{ bool }`
            
        """ # noqa: E501
        return self.__is_assigned

    @is_assigned.setter
    def is_assigned(self, is_assigned):

        self.__is_assigned = is_assigned

    @property
    def is_reserved(self):
        """`{ bool }`
            
        """ # noqa: E501
        return self.__is_reserved

    @is_reserved.setter
    def is_reserved(self, is_reserved):

        self.__is_reserved = is_reserved

    @property
    def is_learned(self):
        """`{ bool }`
            
        """ # noqa: E501
        return self.__is_learned

    @is_learned.setter
    def is_learned(self, is_learned):

        self.__is_learned = is_learned

    @property
    def assigned_details(self):
        """`{ networking.v4.config.AssignedAddressInfo }`
            
        """ # noqa: E501
        return self.__assigned_details

    @assigned_details.setter
    def assigned_details(self, assigned_details):

        self.__assigned_details = assigned_details

    @property
    def learned_details(self):
        """`{ list[networking.v4.config.LearnedAddressInfo] }`
            
        """ # noqa: E501
        return self.__learned_details

    @learned_details.setter
    def learned_details(self, learned_details):

        self.__learned_details = learned_details

    @property
    def reserved_details(self):
        """`{ networking.v4.config.ReservedAddressInfo }`
            
        """ # noqa: E501
        return self.__reserved_details

    @reserved_details.setter
    def reserved_details(self, reserved_details):

        self.__reserved_details = reserved_details

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AddressAssignmentInfo, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddressAssignmentInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

