# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.networking.v4.config.IPSubnet import IPSubnet  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.IbgpConfig import IbgpConfig  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.OspfConfig import OspfConfig  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class InternalRoutingConfig(object):
    """InternalRoutingConfig - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'ospf_config': 'networking.v4.config.OspfConfig',
        'ibgp_config_list': 'list[networking.v4.config.IbgpConfig]',
        'local_prefix_list': 'list[networking.v4.config.IPSubnet]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ospf_config': 'ospfConfig',
        'ibgp_config_list': 'ibgpConfigList',
        'local_prefix_list': 'localPrefixList',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ospf_config=None, ibgp_config_list=None, local_prefix_list=None, *args, **kwargs):  # noqa: E501
        """InternalRoutingConfig - a model defined in Swagger
            \nDescribes the routing protocol configuration spec needed by this gateway to peer and learn routes from internal routers using either iBGP or OSPF. 
        """
        self.__ospf_config = None
        self.__ibgp_config_list = None
        self.__local_prefix_list = None
        self.discriminator = None
        if ospf_config is not None:
            self.__ospf_config = ospf_config
        if ibgp_config_list is not None:
            self.__ibgp_config_list = ibgp_config_list
        if local_prefix_list is not None:
            self.__local_prefix_list = local_prefix_list
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.InternalRoutingConfig'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.InternalRoutingConfig'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ospf_config(self):
        """`{ networking.v4.config.OspfConfig }`
            
        """ # noqa: E501
        return self.__ospf_config

    @ospf_config.setter
    def ospf_config(self, ospf_config):

        self.__ospf_config = ospf_config

    @property
    def ibgp_config_list(self):
        """`{ list[networking.v4.config.IbgpConfig] }`
            \niBGP configuration.
        """ # noqa: E501
        return self.__ibgp_config_list

    @ibgp_config_list.setter
    def ibgp_config_list(self, ibgp_config_list):

        self.__ibgp_config_list = ibgp_config_list

    @property
    def local_prefix_list(self):
        """`{ list[networking.v4.config.IPSubnet] }`
            \nList of local prefixes to be advertised over eBGP.
        """ # noqa: E501
        return self.__local_prefix_list

    @local_prefix_list.setter
    def local_prefix_list(self, local_prefix_list):

        self.__local_prefix_list = local_prefix_list

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(InternalRoutingConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InternalRoutingConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

