# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.UnreserveType import UnreserveType  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class IpUnreserveInput(object):
    """IpUnreserveInput - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'count': 'int',
        'start_ip_address': 'common.v1.config.IPAddress',
        'ip_addresses': 'list[common.v1.config.IPAddress]',
        'client_context': 'str',
        'unreserve_type': 'networking.v4.config.UnreserveType',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'count': 'count',
        'start_ip_address': 'startIpAddress',
        'ip_addresses': 'ipAddresses',
        'client_context': 'clientContext',
        'unreserve_type': 'unreserveType',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, count=None, start_ip_address=None, ip_addresses=None, client_context=None, unreserve_type=None, *args, **kwargs):  # noqa: E501
        """IpUnreserveInput - a model defined in Swagger
            \nInput required to unreserve IP addresses on a subnet.
        """
        self.__count = None
        self.__start_ip_address = None
        self.__ip_addresses = None
        self.__client_context = None
        self.__unreserve_type = None
        self.discriminator = None
        if count is not None:
            self.__count = count
        if start_ip_address is not None:
            self.__start_ip_address = start_ip_address
        if ip_addresses is not None:
            self.__ip_addresses = ip_addresses
        if client_context is not None:
            self.__client_context = client_context
        self.__unreserve_type = unreserve_type
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.IpUnreserveInput'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.IpUnreserveInput'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def count(self):
        """`{ int }`
            \nNumber of IP addresses unreserved.
        """ # noqa: E501
        return self.__count

    @count.setter
    def count(self, count):

        self.__count = count

    @property
    def start_ip_address(self):
        """`{ common.v1.config.IPAddress }`
            
        """ # noqa: E501
        return self.__start_ip_address

    @start_ip_address.setter
    def start_ip_address(self, start_ip_address):

        self.__start_ip_address = start_ip_address

    @property
    def ip_addresses(self):
        """`{ list[common.v1.config.IPAddress] }`
            
        """ # noqa: E501
        return self.__ip_addresses

    @ip_addresses.setter
    def ip_addresses(self, ip_addresses):

        self.__ip_addresses = ip_addresses

    @property
    def client_context(self):
        """`{ str }`
            \nOptional context a client wishes to associate with a reservation of IP addresses.
        """ # noqa: E501
        return self.__client_context

    @client_context.setter
    def client_context(self, client_context):

        self.__client_context = client_context

    @property
    def unreserve_type(self):
        """`{ networking.v4.config.UnreserveType }`
            
        """ # noqa: E501
        return self.__unreserve_type

    @unreserve_type.setter
    def unreserve_type(self, unreserve_type):
        if unreserve_type is None:
            raise ValueError("Invalid value for `unreserve_type`, must not be `None`")  # noqa: E501

        self.__unreserve_type = unreserve_type

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(IpUnreserveInput, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpUnreserveInput):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

