# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.CloudSubstrate import CloudSubstrate  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.ControllerStatus import ControllerStatus  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class NetworkController(NetworkingBaseModel):
    """NetworkController - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'controller_status': 'networking.v4.config.ControllerStatus',
        'controller_version': 'str',
        'minimum_ahv_version': 'str',
        'minimum_nos_version': 'str',
        'cloud_substrate': 'networking.v4.config.CloudSubstrate',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'controller_status': 'controllerStatus',
        'controller_version': 'controllerVersion',
        'minimum_ahv_version': 'minimumAHVVersion',
        'minimum_nos_version': 'minimumNOSVersion',
        'cloud_substrate': 'cloudSubstrate',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, controller_status=None, controller_version=None, minimum_ahv_version=None, minimum_nos_version=None, cloud_substrate=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """NetworkController - a model defined in Swagger
            
        """
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__controller_status = None
        self.__controller_version = None
        self.__minimum_ahv_version = None
        self.__minimum_nos_version = None
        self.__cloud_substrate = None
        self.discriminator = None
        if controller_status is not None:
            self.__controller_status = controller_status
        if controller_version is not None:
            self.__controller_version = controller_version
        if minimum_ahv_version is not None:
            self.__minimum_ahv_version = minimum_ahv_version
        if minimum_nos_version is not None:
            self.__minimum_nos_version = minimum_nos_version
        if cloud_substrate is not None:
            self.__cloud_substrate = cloud_substrate

    def _initialize_object_type(self):
        return 'networking.v4.config.NetworkController'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.NetworkController'


    @property
    def controller_status(self):
        """`{ networking.v4.config.ControllerStatus }`
            
        """ # noqa: E501
        return self.__controller_status

    @controller_status.setter
    def controller_status(self, controller_status):

        self.__controller_status = controller_status

    @property
    def controller_version(self):
        """`{ str }`
            \nNetwork controller software version.
        """ # noqa: E501
        return self.__controller_version

    @controller_version.setter
    def controller_version(self, controller_version):

        self.__controller_version = controller_version

    @property
    def minimum_ahv_version(self):
        """`{ str }`
            \nMinimum AHV version that this network controller supports.
        """ # noqa: E501
        return self.__minimum_ahv_version

    @minimum_ahv_version.setter
    def minimum_ahv_version(self, minimum_ahv_version):

        self.__minimum_ahv_version = minimum_ahv_version

    @property
    def minimum_nos_version(self):
        """`{ str }`
            \nMinimum NOS version that this network controller supports.
        """ # noqa: E501
        return self.__minimum_nos_version

    @minimum_nos_version.setter
    def minimum_nos_version(self, minimum_nos_version):

        self.__minimum_nos_version = minimum_nos_version

    @property
    def cloud_substrate(self):
        """`{ networking.v4.config.CloudSubstrate }`
            
        """ # noqa: E501
        return self.__cloud_substrate

    @cloud_substrate.setter
    def cloud_substrate(self, cloud_substrate):

        self.__cloud_substrate = cloud_substrate

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NetworkController, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkController):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

