# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.Route import Route  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class RouteTable(NetworkingBaseModel):
    """RouteTable - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'vpc_reference': 'str',
        'external_routing_domain_reference': 'str',
        'static_routes': 'list[networking.v4.config.Route]',
        'dynamic_routes': 'list[networking.v4.config.Route]',
        'local_routes': 'list[networking.v4.config.Route]',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vpc_reference': 'vpcReference',
        'external_routing_domain_reference': 'externalRoutingDomainReference',
        'static_routes': 'staticRoutes',
        'dynamic_routes': 'dynamicRoutes',
        'local_routes': 'localRoutes',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vpc_reference=None, external_routing_domain_reference=None, static_routes=None, dynamic_routes=None, local_routes=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """RouteTable - a model defined in Swagger
            \nRoute table
        """
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__vpc_reference = None
        self.__external_routing_domain_reference = None
        self.__static_routes = None
        self.__dynamic_routes = None
        self.__local_routes = None
        self.discriminator = None
        if vpc_reference is not None:
            self.__vpc_reference = vpc_reference
        if external_routing_domain_reference is not None:
            self.__external_routing_domain_reference = external_routing_domain_reference
        if static_routes is not None:
            self.__static_routes = static_routes
        if dynamic_routes is not None:
            self.__dynamic_routes = dynamic_routes
        if local_routes is not None:
            self.__local_routes = local_routes

    def _initialize_object_type(self):
        return 'networking.v4.config.RouteTable'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.RouteTable'


    @property
    def vpc_reference(self):
        """`{ str }`
            \nVPC
        """ # noqa: E501
        return self.__vpc_reference

    @vpc_reference.setter
    def vpc_reference(self, vpc_reference):
        if vpc_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', vpc_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `vpc_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__vpc_reference = vpc_reference

    @property
    def external_routing_domain_reference(self):
        """`{ str }`
            \nThe external routing domain UUID
        """ # noqa: E501
        return self.__external_routing_domain_reference

    @external_routing_domain_reference.setter
    def external_routing_domain_reference(self, external_routing_domain_reference):
        if external_routing_domain_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', external_routing_domain_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `external_routing_domain_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__external_routing_domain_reference = external_routing_domain_reference

    @property
    def static_routes(self):
        """`{ list[networking.v4.config.Route] }`
            \nStatic routes
        """ # noqa: E501
        return self.__static_routes

    @static_routes.setter
    def static_routes(self, static_routes):

        self.__static_routes = static_routes

    @property
    def dynamic_routes(self):
        """`{ list[networking.v4.config.Route] }`
            \nDynamic routes
        """ # noqa: E501
        return self.__dynamic_routes

    @dynamic_routes.setter
    def dynamic_routes(self, dynamic_routes):

        self.__dynamic_routes = dynamic_routes

    @property
    def local_routes(self):
        """`{ list[networking.v4.config.Route] }`
            \nRoutes to local subnets
        """ # noqa: E501
        return self.__local_routes

    @local_routes.setter
    def local_routes(self, local_routes):

        self.__local_routes = local_routes

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RouteTable, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RouteTable):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

