# coding: utf-8


"""
IGNORE:
    Nutanix Networking Versioned APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_networking_py_client.Ntnx.networking.v4.config.RoutingPolicyAction import RoutingPolicyAction  # noqa: F401,E501
from ntnx_networking_py_client.Ntnx.networking.v4.config.RoutingPolicyMatchCondition import RoutingPolicyMatchCondition  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class RoutingPolicyRule(object):
    """RoutingPolicyRule - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'policy_match': 'networking.v4.config.RoutingPolicyMatchCondition',
        'policy_action': 'networking.v4.config.RoutingPolicyAction',
        'bidirectional': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'policy_match': 'policyMatch',
        'policy_action': 'policyAction',
        'bidirectional': 'bidirectional',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, policy_match=None, policy_action=None, bidirectional=False, *args, **kwargs):  # noqa: E501
        """RoutingPolicyRule - a model defined in Swagger
            \nPolicy indicating the match rule and the action.
        """
        self.__policy_match = None
        self.__policy_action = None
        self.__bidirectional = None
        self.discriminator = None
        self.__policy_match = policy_match
        self.__policy_action = policy_action
        if bidirectional is not None:
            self.__bidirectional = bidirectional
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.RoutingPolicyRule'

    def _initialize_fq_object_type(self):
        return 'networking.v4.r0.a1.config.RoutingPolicyRule'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def policy_match(self):
        """`{ networking.v4.config.RoutingPolicyMatchCondition }`
            
        """ # noqa: E501
        return self.__policy_match

    @policy_match.setter
    def policy_match(self, policy_match):
        if policy_match is None:
            raise ValueError("Invalid value for `policy_match`, must not be `None`")  # noqa: E501

        self.__policy_match = policy_match

    @property
    def policy_action(self):
        """`{ networking.v4.config.RoutingPolicyAction }`
            
        """ # noqa: E501
        return self.__policy_action

    @policy_action.setter
    def policy_action(self, policy_action):
        if policy_action is None:
            raise ValueError("Invalid value for `policy_action`, must not be `None`")  # noqa: E501

        self.__policy_action = policy_action

    @property
    def bidirectional(self):
        """`{ bool }`
            \nIf True, policies in the reverse direction will be installed with the same action but source and destination will be swapped.
        """ # noqa: E501
        return self.__bidirectional

    @bidirectional.setter
    def bidirectional(self, bidirectional):

        self.__bidirectional = bidirectional

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """
        Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.
        :param bool sanitize
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RoutingPolicyRule, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dict"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoutingPolicyRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

